                .include "sys_regs.i"
                .include "gfx_regs.i"
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  _pctrl_irq4_handler

_pctrl_irq4_handler:
                movem.l %d0-%d1/%a0,-(%sp)
                move.l  PERIPHERAL_CTRL_SPI_DATA_REG,_evnt_code
                move.b  _evnt_code+0,%d0
                andi.l  #0xF0,%d0
                cmpi.b  #0xD0,%d0
                beq.w   _mouse_irq_handler    |jump to mouse IRQ handler
                cmpi.b  #0xE0,%d0
                beq.w   _keyboard_irq_handler |jump to keyboard IRQ handler
_irq4_handler_exit:
                movem.l (%sp)+, %d0-%d1/%a0
                rte

|                lea     _evnt_buffer,%a0
|                move.w  _evb_wr_ptr,%d0
|                move.l  _evnt_code,(%a0,%d0.w)
|                addq.w  #0x04,%d0
|                andi.w  #0x01FC,%d0
|                move.w  %d0,_evb_wr_ptr

|---------------------------------------------------------------------------
                .align  2
_evnt_code:     ds.l    1
| _evb_wr_ptr:    ds.w    1
| _evb_rd_ptr:    ds.w    1
| _evnt_buffer:   ds.l    128
|---------------------------------------------------------------------------
                .align  2
_keyboard_irq_handler:
                lea     _keybuf,%a0
                clr.l   %d0
                move.b  _keybuf_wr_ptr,%d0
                move.b  _evnt_code+3,(%a0,%d0.w)
                addq.b  #0x01,%d0
                andi.b  #0x3F,%d0
                move.b  %d0,_keybuf_wr_ptr
                move.b  _evnt_code+3,%d0
                cmpi.b  #0x0E,%d0             | scroll lock ->
                bne.s   _kbi_v0
                trap    #15                   | force trap #15 exception
_kbi_v0:
     |test for CTRL pressed
                cmpi.b  #0x01,%d0 
                beq.s   _kbi_c3
                cmpi.b  #0x04,%d0
                bne.s   _kbi_c4
_kbi_c3:        move.b  %d0,_ctrl_pressed
                bra.s   _kbi_p0
_kbi_c4:
     |test for CTRL released
                cmpi.b  #0x81,%d0
                beq.s   _kbi_c5
                cmpi.b  #0x84,%d0
                bne.s   _kbi_c6
_kbi_c5:        clr.b   _ctrl_pressed
                bra.s   _kbi_p0
_kbi_c6:
     |test for ALT pressed
                cmpi.b  #0x03,%d0
                beq.s   _kbi_a3
                cmpi.b  #0x06,%d0
                bne.s   _kbi_a4
_kbi_a3:        move.b  %d0,_alt_pressed
                bra.s   _kbi_p0
_kbi_a4:
     |test for ALT released
                cmpi.b  #0x83,%d0
                beq.s   _kbi_a5
                cmpi.b  #0x86,%d0
                bne.s   _kbi_a6
_kbi_a5:        clr.b   _alt_pressed
                bra.s   _kbi_p0
_kbi_a6:
     |test for DEL pressed
                cmpi.b  #0x22,%d0
                bne.s   _kbi_p0
                tst.b   _ctrl_pressed
                beq.s   _kbi_p0
                tst.b   _alt_pressed
                beq.s   _kbi_p0
                jmp     sys_restart           |ctrl_alt_del pressed!

_kbi_p0:        bra.w   _irq4_handler_exit
|---------------------------------------------------------------------------
_keybuf_wr_ptr: ds.b    1
_keybuf_rd_ptr: ds.b    1
_keybuf:        ds.b    64
_ctrl_pressed:  ds.b    1
_alt_pressed:   ds.b    1
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  key_pressed
                .type   key_pressed, @function
key_pressed:
                move.b  _keybuf_wr_ptr,%d0
                cmp.b   _keybuf_rd_ptr,%d0
                sne     %d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  get_key
                .type   get_key, @function
get_key:
                movem.l %d1/%a0,-(%sp)
                clr.w   %d1
                clr.l   %d0
                move.b  _keybuf_rd_ptr,%d1
                cmp.b   _keybuf_wr_ptr,%d1
                beq.s   _gk_exit
                lea     _keybuf,%a0
                move.b  (%a0,%d1.w),%d0
                addq.b  #0x01,%d1
                andi.b  #0x3F,%d1
                move.b  %d1,_keybuf_rd_ptr
_gk_exit:
                movem.l (%sp)+,%d1/%a0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  clear_keyboard_buffer
                .type   clear_keyboard_buffer, @function
clear_keyboard_buffer:
                clr.b   _keybuf_wr_ptr
                clr.b   _keybuf_rd_ptr
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  _pctrl_init

_pctrl_init:

| ---- init keyboard driver
                clr.b   _ctrl_pressed
                clr.b   _alt_pressed
                bsr.s   clear_keyboard_buffer

| ---- init mouse driver
                clr.b   _mouse_b
                move.w  #0x77FF,_mouse_crossptr_mode_cw
                bsr     mouse_hide
                bsr     set_mouse_window_fullscreen

| ---- init pctrl event driver

|                clr.w   _evb_wr_ptr
|                clr.w   _evb_rd_ptr
                ori.w   #0x0010,INTERRUPT_MASK_REGISTER_L
                move.b  #0xC0,PERIPHERAL_CTRL_SPI_CONTROL_REG
                rts


|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  mouse_show
                .type   mouse_show, @function
mouse_show:
                move.w  _mouse_crossptr_mode_cw,OVERLAY_CROSS_POINTER_CTRL_REG
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  mouse_hide
                .type   mouse_hide, @function
mouse_hide:
                clr.w   OVERLAY_CROSS_POINTER_CTRL_REG
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  set_mouse_crosspointer_control_word
                .type   set_mouse_crosspointer_control_word, @function

set_mouse_crosspointer_control_word:
                move.w  6(%sp),_mouse_crossptr_mode_cw
                bra.s   mouse_show
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  get_mouse_crosspointer_control_word
                .type   get_mouse_crosspointer_control_word, @function
get_mouse_crosspointer_control_word:
                clr.l   %d0
                move.w  _mouse_crossptr_mode_cw,%d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  mouse_in
                .type   mouse_in, @function

| y2.. x2.. y1.. x1.. RRRR
| +18  +14  +10  +6   sp

mouse_in:
                move.w  _mouse_x,%d0
                cmp.w   6(%sp),%d0            |x1
                blo.s   _mou_in_e0
                cmp.w   14(%sp),%d0           |x2
                bhi.s   _mou_in_e0
                move.w  _mouse_y,%d0
                cmp.w   10(%sp),%d0           |y1
                blo.s   _mou_in_e0
                cmp.w   18(%sp),%d0           |y2
                bhi.s   _mou_in_e0
                st      %d0
                rts
_mou_in_e0:
                clr.l   %d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  mouse_pressed
                .type   mouse_pressed, @function
mouse_pressed:
                tst.b   _mouse_b
                sne     %d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  get_mouse_buttons
                .type   get_mouse_buttons, @function

get_mouse_buttons:
                move.b   _mouse_b,%d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  get_mouse_x
                .type   get_mouse_x, @function
get_mouse_x:
                move.w  _mouse_x,%d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  get_mouse_y
                .type   get_mouse_y, @function
get_mouse_y:
                move.w  _mouse_y,%d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  set_mouse_window
                .type   set_mouse_window, @function

| y2.. x2.. y1.. x1.. RRRR
| +18  +14  +10  +6   sp

set_mouse_window:
                movem.l %d0-%d1,-(%sp)
 |----- X
                move.w  #639,%d1
                move.w  8+6(%sp),%d0            |x1
                cmp.w   %d1,%d0
                bls.s   _mou_setwnd_g1
                move.w  %d1,%d0
_mou_setwnd_g1:
                move.w  %d0,_mouse_window_x1
                move.w  8+14(%sp),%d0           |x2
                cmp.w   %d1,%d0
                bls.s   _mou_setwnd_g2
                move.w  %d1,%d0
_mou_setwnd_g2:         
                move.w  %d0,_mouse_window_x2
 |----- Y
                move.w  #479,%d1
                move.w  8+10(%sp),%d0            |y1
                cmp.w   %d1,%d0
                bls.s   _mou_setwnd_g3
                move.w  %d1,%d0
_mou_setwnd_g3:
                move.w  %d0,_mouse_window_y1
                move.w  8+18(%sp),%d0             |y2
                cmp.w   %d1,%d0
                bls.s   _mou_setwnd_g4
                move.w  %d1,%d0
_mou_setwnd_g4:
                move.w  %d0,_mouse_window_y2

 |----- force mouse into new window
                
                move.w  _mouse_window_x1,%d0
                add.w   _mouse_window_x2,%d0
                lsr.w   #1,%d0
                move.w  _mouse_window_y1,%d1
                add.w   _mouse_window_y2,%d1
                lsr.w   #1,%d1
                move.l  %d1,-(%sp)
                move.l  %d0,-(%sp)
                bsr.s   mouse_goto_xy
                addq.l  #8,%sp
                movem.l (%sp)+,%d0-%d1
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  mouse_goto_xy
                .type   mouse_goto_xy, @function

| y1.. x1.. RRRR
| +10  +6   sp
mouse_goto_xy:
                move.w  6(%sp),_mouse_x
                move.w  6(%sp),OVERLAY_CROSS_POINTER_X_REG
                move.w  10(%sp),_mouse_y
                move.w  10(%sp),OVERLAY_CROSS_POINTER_Y_REG
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  set_mouse_window_fullscreen
                .type   set_mouse_window_fullscreen, @function

set_mouse_window_fullscreen:

                pea     479
                pea     639
                clr.l   -(%sp)
                clr.l   -(%sp)
                bsr     set_mouse_window
                lea     16(%sp),%sp
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
_mouse_irq_handler:

| ---- X coordinate processing
                 
                btst.b  #4,_evnt_code+3       |X sign bit
                sne.b   %d0                   |d0=FF if sign=1 / 00 if sign=0
                ext.w   %d0                   |d0=FFFF/0000
                move.b  _evnt_code+2,%d0      |inject X movement byte  to d0
                move.w  _mouse_x,%d1
                add.w   %d0,%d1
                bpl.s   _mou_i4h_px1
                clr.w   %d1
_mou_i4h_px1:
                cmp.w   _mouse_window_x2,%d1
                bls.s   _mou_i4h_px2
                move.w  _mouse_window_x2,%d1
_mou_i4h_px2:
                cmp.w   _mouse_window_x1,%d1
                bhs.s   _mou_i4h_px3
                move.w  _mouse_window_x1,%d1
_mou_i4h_px3:
                move.w  %d1,_mouse_x
                move.w  %d1,OVERLAY_CROSS_POINTER_X_REG

| ---- Y coordinate processing

                btst.b  #5,_evnt_code+3       |Y sign bit
                sne.b   %d0                   |d0=FF if sign=1 / 00 if sign=0
                ext.w   %d0                   |d0=FFFF/0000
                move.b  _evnt_code+1,%d0      |inject Y movement byte  to d0
                move.w  _mouse_y,%d1
                sub.w   %d0,%d1
                bpl.s   _mou_i4h_py1
                clr.w   %d1
_mou_i4h_py1:
                cmp.w   _mouse_window_y2,%d1
                bls.s   _mou_i4h_py2
                move.w  _mouse_window_y2,%d1
_mou_i4h_py2:
                cmp.w   _mouse_window_y1,%d1
                bhs.s   _mou_i4h_py3
                move.w  _mouse_window_y1,%d1
_mou_i4h_py3:
                move.w  %d1,_mouse_y
                move.w  %d1,OVERLAY_CROSS_POINTER_Y_REG
                
| ---- Buttons processing

                move.b  _evnt_code+3,%d0
                andi.b  #7,%d0
                move.b  %d0,_mouse_b

                bra.w   _irq4_handler_exit

|---------------------------------------------------------------------------
                .align  2
_mouse_crossptr_mode_cw:        ds.w    1
_mouse_window_x1:               ds.w    1
_mouse_window_x2:               ds.w    1
_mouse_window_y1:               ds.w    1
_mouse_window_y2:               ds.w    1
_mouse_x:                       ds.w    1
_mouse_y:                       ds.w    1
_mouse_b:                       ds.b    1
|---------------------------------------------------------------------------

