|----------------------------------------------------------------------------
                .include "sys_regs.i"
|----------------------------------------------------------------------------
                .section .text 
                .align  2
                .globl  _cpu_reset_entry
_cpu_reset_entry:
                move.w  #0x2700, %sr 
                movea.l (0), %sp
                bsr     _interrupt_controller_init
                bsr     _clear_all_user_irq_handlers
                bsr     _timer3_init
                bsr     _rs232_initialize
                bsr     _midi1_initialize
                bsr     _midi2_initialize
                bsr     _pctrl_init
                bsr     _rhytm_gen_initialize
                bsr     gfx_initialize
                pea     0x1A7F6CB3
                bsr     init_rnd32
                addq.l  #0x04,%sp
                bsr     main                  |go!
                bsr     gfx_initialize
                pea     _sys_pgmtrm_msg
                pea     7
                clr.l   -(%sp)
                pea     0x0A
                pea     230
                pea     200
                bsr     gfx_draw_text
                lea     24(%sp),%sp
                pea     0
                bsr.w   sys_halt              |no return here...
_sys_pgmtrm_msg:        .asciz "PROGRAM TERMINATED.  SYSTEM HALTED."
|----------------------------------------------------------------------------
                .align  2
                .globl  _exception_bus_error
_exception_bus_error:
                move.w  %sr,_registers_dump+68
                move.l  #_exc02_msg,_exception_msg_ptr
                move.b  #2,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_addr_error
_exception_addr_error:
                move.w  %sr,_registers_dump+68
                move.l  #_exc03_msg,_exception_msg_ptr
                move.b  #3,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_illegal_instr
_exception_illegal_instr:
                move.w  %sr,_registers_dump+68
                move.l  #_exc04_msg,_exception_msg_ptr
                move.b  #4,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_zero_div
_exception_zero_div:
                move.w  %sr,_registers_dump+68
                move.l  #_exc05_msg,_exception_msg_ptr
                move.b  #5,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_chk_instr
_exception_chk_instr:
                move.w  %sr,_registers_dump+68
                move.l  #_exc06_msg,_exception_msg_ptr
                move.b  #6,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_trapv_instr
_exception_trapv_instr:
                move.w  %sr,_registers_dump+68
                move.l  #_exc07_msg,_exception_msg_ptr
                move.b  #7,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_priv_violation
_exception_priv_violation:
                move.w  %sr,_registers_dump+68
                move.l  #_exc08_msg,_exception_msg_ptr
                move.b  #8,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_trace_vector
_exception_trace_vector:
                move.w  %sr,_registers_dump+68
                move.l  #_exc09_msg,_exception_msg_ptr
                move.b  #9,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_emu1010
_exception_emu1010:
                move.w  %sr,_registers_dump+68
                move.l  #_exc10_msg,_exception_msg_ptr
                move.b  #10,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_emu1111
_exception_emu1111:
                move.w  %sr,_registers_dump+68
                move.l  #_exc11_msg,_exception_msg_ptr
                move.b  #11,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_uninit_int
_exception_uninit_int:
                move.w  %sr,_registers_dump+68
                move.l  #_exc15_msg,_exception_msg_ptr
                move.b  #15,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_spur_int
_exception_spur_int:
                move.w  %sr,_registers_dump+68
                move.l  #_exc24_msg,_exception_msg_ptr
                move.b  #24,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_autovect_int
_exception_autovect_int:
                move.w  %sr,_registers_dump+68
                move.l  #_exc25_msg,_exception_msg_ptr
                move.b  #25,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap0
_exception_unused_trap0:
                move.w  %sr,_registers_dump+68
                move.l  #_exc32_msg,_exception_msg_ptr
                move.b  #32,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap1
_exception_unused_trap1:
                move.w  %sr,_registers_dump+68
                move.l  #_exc33_msg,_exception_msg_ptr
                move.b  #33,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap2
_exception_unused_trap2:
                move.w  %sr,_registers_dump+68
                move.l  #_exc34_msg,_exception_msg_ptr
                move.b  #34,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap3
_exception_unused_trap3:
                move.w  %sr,_registers_dump+68
                move.l  #_exc35_msg,_exception_msg_ptr
                move.b  #35,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap4
_exception_unused_trap4:
                move.w  %sr,_registers_dump+68
                move.l  #_exc36_msg,_exception_msg_ptr
                move.b  #36,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap5
_exception_unused_trap5:
                move.w  %sr,_registers_dump+68
                move.l  #_exc37_msg,_exception_msg_ptr
                move.b  #37,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap6
_exception_unused_trap6:
                move.w  %sr,_registers_dump+68
                move.l  #_exc38_msg,_exception_msg_ptr
                move.b  #38,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap7
_exception_unused_trap7:
                move.w  %sr,_registers_dump+68
                move.l  #_exc39_msg,_exception_msg_ptr
                move.b  #39,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap8
_exception_unused_trap8:
                move.w  %sr,_registers_dump+68
                move.l  #_exc40_msg,_exception_msg_ptr
                move.b  #40,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap9
_exception_unused_trap9:
                move.w  %sr,_registers_dump+68
                move.l  #_exc41_msg,_exception_msg_ptr
                move.b  #41,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap10
_exception_unused_trap10:
                move.w  %sr,_registers_dump+68
                move.l  #_exc42_msg,_exception_msg_ptr
                move.b  #42,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap11
_exception_unused_trap11:
                move.w  %sr,_registers_dump+68
                move.l  #_exc43_msg,_exception_msg_ptr
                move.b  #43,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap12
_exception_unused_trap12:
                move.w  %sr,_registers_dump+68
                move.l  #_exc44_msg,_exception_msg_ptr
                move.b  #44,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap13
_exception_unused_trap13:
                move.w  %sr,_registers_dump+68
                move.l  #_exc45_msg,_exception_msg_ptr
                move.b  #45,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap14
_exception_unused_trap14:
                move.w  %sr,_registers_dump+68
                move.l  #_exc46_msg,_exception_msg_ptr
                move.b  #46,_exception_num
                bra.w   _unhandled_exception

                .globl  _exception_unused_trap15
_exception_unused_trap15:
                move.w  %sr,_registers_dump+68
                move.l  #_exc47_msg,_exception_msg_ptr
                move.b  #47,_exception_num
                bra.w   _unhandled_exception

                .globl  _exc_unused
_exc_unused:
                move.w  %sr,_registers_dump+68
                move.l  #_exc255_msg,_exception_msg_ptr
                move.b  #255,_exception_num
                bra.w   _unhandled_exception
                nop
              
|----------------------------------------------------------------------------
                .section .text
                .align  2
_unhandled_exception:
                move.w  #0x2700, %sr 
                movem.l %d0-%d7/%a0-%a7,_registers_dump
                move.l  %usp,%a0
                move.l  %a0,_registers_dump+64
                pea     0x0F
                jsr     gfx_load_led_register
                addq.l  #0x04,%sp
                pea     _registers_dump
                move.l  _exception_msg_ptr,-(%sp)
                clr.l   %d0
                move.b  _exception_num,%d0
                move.l  %d0,-(%sp)
                jsr     common_exception_handler
                move.w  #0x2700, %sr 
 _exc_h_hlt:    bra.s   _exc_h_hlt
|----------------------------------------------------------------------------
                .section .text
                .align  2
|--- IRQ0  -------------------------------------------
                .globl  _sys_irq0_entry
_sys_irq0_entry:
                tst.b   _irq_handlers_flags + 0
                beq     _rhytm_gen_irq0_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (0 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 0
                bne     _rhytm_gen_irq0_handler
                rte
|--- IRQ1  -------------------------------------------
                .globl  _sys_irq1_entry
_sys_irq1_entry:
                tst.b   _irq_handlers_flags + 1
                beq.s   _sys_irq1_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (1 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 1
                bne.s   _sys_irq1_default
                rte
_sys_irq1_default:
                move.b  #0x41,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ2  -------------------------------------------
                .globl  _sys_irq2_entry
_sys_irq2_entry:
                tst.b   _irq_handlers_flags + 2
                beq.s   _sys_irq2_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (2 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 2
                bne.s   _sys_irq2_default
                rte
_sys_irq2_default:
                move.b  #0x42,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ3  -------------------------------------------
                .globl  _sys_irq3_entry
_sys_irq3_entry:
                tst.b   _irq_handlers_flags + 3
                beq     _timer3_irq3_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (3 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 3
                bne     _timer3_irq3_handler
                rte
|--- IRQ4  -------------------------------------------
                .globl  _sys_irq4_entry
_sys_irq4_entry:
                tst.b   _irq_handlers_flags + 4
                beq     _pctrl_irq4_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (4 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 4
                bne     _pctrl_irq4_handler
                rte
|--- IRQ5  -------------------------------------------
                .globl  _sys_irq5_entry
_sys_irq5_entry:
                tst.b   _irq_handlers_flags + 5
                beq.s   _sys_irq5_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (5 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 5
                bne.s   _sys_irq5_default
                rte
_sys_irq5_default:
                move.b  #0x45,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ6  -------------------------------------------
                .globl  _sys_irq6_entry
_sys_irq6_entry:
                tst.b   _irq_handlers_flags + 6
                beq.s   _sys_irq6_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (6 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 6
                bne.s   _sys_irq6_default
                rte
_sys_irq6_default:
                move.b  #0x46,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ7  -------------------------------------------
                .globl  _sys_irq7_entry
_sys_irq7_entry:
                tst.b   _irq_handlers_flags + 7
                beq     _gfx_irq7_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (7 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 7
                bne     _gfx_irq7_handler
                rte
|--- IRQ8  -------------------------------------------
                .globl  _sys_irq8_entry
_sys_irq8_entry:
                tst.b   _irq_handlers_flags + 8
                beq.s   _sys_irq8_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (8 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 8
                bne.s   _sys_irq8_default
                rte
_sys_irq8_default:
                move.b  #0x48,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ9  -------------------------------------------
                .globl  _sys_irq9_entry
_sys_irq9_entry:
                tst.b   _irq_handlers_flags + 9
                beq     _rs232_rx_irq9_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (9 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 9
                bne     _rs232_rx_irq9_handler
                rte
|--- IRQ10 -------------------------------------------
                .globl  _sys_irq10_entry
_sys_irq10_entry:
                tst.b   _irq_handlers_flags + 10
                beq     _midi1_rx_irq10_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (10 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 10
                bne    _midi1_rx_irq10_handler
                rte
|--- IRQ11 -------------------------------------------
                .globl  _sys_irq11_entry
_sys_irq11_entry:
                tst.b   _irq_handlers_flags + 11
                beq     _midi2_rx_irq11_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (11 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 11
                bne     _midi2_rx_irq11_handler
                rte
|--- IRQ12 -------------------------------------------
                .globl  _sys_irq12_entry
_sys_irq12_entry:
                tst.b   _irq_handlers_flags + 12
                beq.s   _sys_irq12_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (12 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 12
                bne.s   _sys_irq12_default
                rte
_sys_irq12_default:
                move.b  #0x4C,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ13 -------------------------------------------
                .globl  _sys_irq13_entry
_sys_irq13_entry:
                tst.b   _irq_handlers_flags + 13
                beq     _rs232_tx_irq13_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (13 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 13
                bne     _rs232_tx_irq13_handler
                rte
|--- IRQ14 -------------------------------------------
                .globl  _sys_irq14_entry
_sys_irq14_entry:
                tst.b   _irq_handlers_flags + 14
                beq     _midi1_tx_irq14_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (14 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 14
                bne     _midi1_tx_irq14_handler
                rte
|--- IRQ15 -------------------------------------------
                .globl  _sys_irq15_entry
_sys_irq15_entry:
                tst.b   _irq_handlers_flags + 15
                beq     _midi2_tx_irq15_handler
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (15 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 15
                bne     _midi2_tx_irq15_handler
                rte
|--- IRQ16 -------------------------------------------
                .globl  _sys_irq16_entry
_sys_irq16_entry:
                tst.b   _irq_handlers_flags + 16
                beq.s   _sys_irq16_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (16 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 16
                bne.s   _sys_irq16_default
                rte
_sys_irq16_default:
                move.b  #0x50,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ17 -------------------------------------------
                .globl  _sys_irq17_entry
_sys_irq17_entry:
                tst.b   _irq_handlers_flags + 17
                beq.s   _sys_irq17_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (17 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 17
                bne.s   _sys_irq17_default
                rte
_sys_irq17_default:
                move.b  #0x51,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ18 -------------------------------------------
                .globl  _sys_irq18_entry
_sys_irq18_entry:
                tst.b   _irq_handlers_flags + 18
                beq.s   _sys_irq18_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (18 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 18
                bne.s   _sys_irq18_default
                rte
_sys_irq18_default:
                move.b  #0x52,_exception_num
                bra     _exception_uninitialized_irq_vector
|--- IRQ19 -------------------------------------------
                .globl  _sys_irq19_entry
_sys_irq19_entry:
                tst.b   _irq_handlers_flags + 19
                beq.s   _sys_irq19_default
                movem.l %d0-%d7/%a0-%a6,-(%sp)
                movea.l _irq_handlers_table + (19 *4),%a0
                jsr      (%a0)
                movem.l (%sp)+,%d0-%d7/%a0-%a6
                tst.b   _irq_default_handlers_flags + 19
                bne.s   _sys_irq19_default
                rte
_sys_irq19_default:
                move.b  #0x53,_exception_num
                bra     _exception_uninitialized_irq_vector
|----------------------------------------------------------------------------
                nop
_exception_uninitialized_irq_vector:
                move.w  %sr,_registers_dump+68
                move.l  #_exc_uirq_msg,_exception_msg_ptr
                bra.w   _unhandled_exception
|----------------------------------------------------------------------------

|----------------------------------------------------------------------------
                .section .text
_exc02_msg:     .asciz  "BUS CYCLE ERROR"
_exc03_msg:     .asciz  "ADDRESS ERROR"
_exc04_msg:     .asciz  "INVALID INSTRUCTION OPCODE"
_exc05_msg:     .asciz  "DIVIDE BY ZERO"
_exc06_msg:     .asciz  "CHK INSTRUCTION VECTOR"
_exc07_msg:     .asciz  "TRAPV INSTRUCTION VECTOR"
_exc08_msg:     .asciz  "PRIVILEGE VIOLATION"
_exc09_msg:     .asciz  "TRACE VECTOR"
_exc10_msg:     .asciz  "$AXXX EMULATION VECTOR"
_exc11_msg:     .asciz  "$FXXX EMULATION VECTOR"
_exc15_msg:     .asciz  "UNINITIALIZED INTERRUPT"
_exc24_msg:     .asciz  "SPURIOUS INTERRUPT"
_exc25_msg:     .asciz  "INVALID AUTOVECTOR INTERRUPT"

_exc32_msg:     .asciz  "TRAP #0"
_exc33_msg:     .asciz  "TRAP #1"
_exc34_msg:     .asciz  "TRAP #2"
_exc35_msg:     .asciz  "TRAP #3"
_exc36_msg:     .asciz  "TRAP #4"
_exc37_msg:     .asciz  "TRAP #5"
_exc38_msg:     .asciz  "TRAP #6"
_exc39_msg:     .asciz  "TRAP #7"
_exc40_msg:     .asciz  "TRAP #8"
_exc41_msg:     .asciz  "TRAP #9"
_exc42_msg:     .asciz  "TRAP #10"
_exc43_msg:     .asciz  "TRAP #11"
_exc44_msg:     .asciz  "TRAP #12"
_exc45_msg:     .asciz  "TRAP #13"
_exc46_msg:     .asciz  "TRAP #14"
_exc47_msg:     .asciz  "TRAP #15"
_exc_uirq_msg:  .asciz  "UNINITIALIZED IRQ"
_exc255_msg:    .asciz  "??? UNKNOWN EXCEPTION"

|----------------------------------------------------------------------------
                .section .text
                .ascii  "EXCN"
_exception_num:
                ds.b    1
                .align  2
_exception_msg_ptr:
                ds.l    1
                .ascii  "DUMP"
                .align  2
_registers_dump:
                ds.l    18

|----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  sys_enable_interrupts
                .type   sys_enable_interrupts, @function
sys_enable_interrupts:
                move    #0x2500,%sr
                rts
|----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  sys_disable_interrupts
                .type   sys_disable_interrupts, @function
sys_disable_interrupts:
                move    #0x2700,%sr
                rts
|----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  sys_restart
                .type   sys_restart, @function
sys_restart:
                move    #0x2700,%sr
                move.l  (0),%sp
                move.l  (4),%a0
                jmp     (%a0)

|----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  sys_install_irq_handler
                .type   sys_install_irq_handler, @function

| *ptr m... irq. RRRR
|  +12 +11  +7   sp

sys_install_irq_handler:
                movem.l %d0-%d1/%a0,-(%sp)
                clr.l   %d0
                move.b  12+7(%sp),%d0          | IRQ number 0..19
                cmpi.b  #19,%d0
                bhi.s   _sys_iirqh_e
                lsl.w   #2,%d0                |*4
                lea     _irq_handlers_table,%a0
                move    %sr,%d1
                move    #0x2700,%sr
                move.l  12+12(%sp),(%a0,%d0.w) |handler ptr
                lsr.w   #2,%d0                |/4
                lea     _irq_default_handlers_flags,%a0
                move.b  12+11(%sp),(%a0,%d0.w) |default_handler enable/disable
                lea     _irq_handlers_flags,%a0
                move.b  0xFF,(%a0,%d0.w)      | user_handler enable
                move    %d1,%sr
_sys_iirqh_e:
                movem.l (%sp)+,%d0-%d1/%a0
                rts
|----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  sys_uninstall_irq_handler
                .type   sys_uninstall_irq_handler, @function

sys_uninstall_irq_handler:
                movem.l %d0-%d1/%a0,-(%sp)
                clr.l   %d0
                move.b  12+7(%sp),%d0          | IRQ number 0..19
                cmpi.b  #19,%d0
                bhi.s   _sys_uirqh_1
                move    %sr,%d1
                move    #0x2700,%sr
                lea     _irq_handlers_flags,%a0
                clr.b   (%a0,%d0.w)            | user_handler disable
                move    %d1,%sr
_sys_uirqh_1:
                movem.l (%sp)+,%d0-%d1/%a0
                rts
|----------------------------------------------------------------------------
                .align  2
_clear_all_user_irq_handlers:
                lea     _irq_handlers_flags,%a0
                moveq   #19,%d0
_sys_init_irqf: clr.b   (%a0)
                dbf     %d0,_sys_init_irqf
                rts
|----------------------------------------------------------------------------
_interrupt_controller_init:
                clr.w   INTERRUPT_MASK_REGISTER_H
                clr.w   INTERRUPT_MASK_REGISTER_L
                move.w  #0x000F,INTERRUPT_POLL_CLEAR_REGISTER_H
                move.w  #0xFFFF,INTERRUPT_POLL_CLEAR_REGISTER_L
                rts
|----------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  sys_halt
                .type   sys_halt, @function
sys_halt:
                move    #0x2700,%sr
                move.l  4(%sp),_sys_hlt_code
_sys_hlt:
                bra.s   _sys_hlt
                .align  2
                .ascii  "HALT"
_sys_hlt_code:  ds.l    1
|----------------------------------------------------------------------------
                .section .text
                .align  4
_irq_handlers_table:
                .ds.l   20
_irq_default_handlers_flags:
                .ds.b   20
_irq_handlers_flags:
                .ds.b   20

|   .section .data
|   .align 2
|   ds.w 1

