|---------------------------------------------------------------------------
                .include "sys_regs.i"
|---------------------------------------------------------------------------
|###########################################################################
|                            RHYTM GENERATOR
|###########################################################################
                .section .text
                .align  2
                .globl  _rhytm_gen_initialize
_rhytm_gen_initialize:
                andi.w  #0xFFFE,INTERRUPT_MASK_REGISTER_L       | mask irq0
                move.w  #0x0001,INTERRUPT_POLL_CLEAR_REGISTER_L | clear irq0
                move.b  #0x05,RHYTM_GENERATOR_CONTROL_REGISTER  | 10khz clk
                move.l  #429497,  RHYTM_GENERATOR_K_REGISTER    | 1hz rate
                ori.b   #0x10,RHYTM_GENERATOR_CONTROL_REGISTER | LS=1
                ori.w   #0x0001,INTERRUPT_MASK_REGISTER_L       | unmask irq0
                rts
|---------------------------------------------------------------------------

                .section .text
                .align  2
                .globl  _rhytm_gen_irq0_handler
_rhytm_gen_irq0_handler:

|     clr.l -(%sp)
|     bsr midi2_send_byte
 |    addq.l #4,%sp

                rte
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  rhytm_gen_start
                .type   rhytm_gen_start, @function
rhytm_gen_start:
                ori.b   #0x40,RHYTM_GENERATOR_CONTROL_REGISTER |enable irq
                ori.b   #0xC0,RHYTM_GENERATOR_CONTROL_REGISTER |enable cnt
                rts   
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  rhytm_gen_stop
                .type   rhytm_gen_stop, @function
rhytm_gen_stop:
                andi.b  #0x27,RHYTM_GENERATOR_CONTROL_REGISTER |disable cnt
                rts   
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  rhytm_gen_set_clk_mux
                .type   rhytm_gen_set_clk_mux, @function
rhytm_gen_set_clk_mux:
                move.l  %d0,-(%sp)
                clr.b   RHYTM_GENERATOR_CONTROL_REGISTER       |disable cnt
                move.b  4+7(%sp),%d0
                andi.b  #7,%d0
                move.b  %d0,RHYTM_GENERATOR_CONTROL_REGISTER   |set CSn
                move.l  (%sp)+,%d0
                rts
|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  rhytm_gen_load_k
                .type   rhytm_gen_load_k, @function
rhytm_gen_load_k:
                move.l  4(%sp),RHYTM_GENERATOR_K_REGISTER      |load k
                ori.b   #0x10,RHYTM_GENERATOR_CONTROL_REGISTER | LS=1
                rts
|###########################################################################
|                               TIMER - 3
|###########################################################################
                .section .text
                .align  2
                .globl  _timer3_irq3_handler

_timer3_irq3_handler:
                move.l  %d0,-(%sp)
                addq.w  #1,_timer3_counter16

   move.w  _timer3_counter16,%d0
   move.l  %d0,-(%sp)
   bsr     gfx_load_led_register
   addq.l  #0x04,%sp

                move.l  (%sp)+,%d0
                rte

|---------------------------------------------------------------------------
                .section .text
                .align  2
                .globl  _timer3_init

|1514131211109876543210ķ
| EN EI 0  F  0 PS2PS1PS0C7 C6 C5 C4 C3 C2 C1 C0 
|Ľ
|EN=0 - disable timer-3  and clear the counter (zero)
|EN=1 - enable timer-3 and start counter
|EI=0 - disable timer-3 interrupt (IRQ3)
|EI=1 - enable timer-3 interrupt (IRQ3)
|F=1 (read)  timer-3 event flag
|F=1 (write) event flag clear
|PSn  - timer-3 clock frequency multiplexer select:
|   000 - 125 kHz
|   001 - 10 kHz
|   010 - 5 kHz
|   011 - 2 kHz
|   100 - 1 kHz
|   101 - 500 Hz
|   110 - 250 Hz
|   111 - 125 Hz
|Cn= 1..255 8-bit comparator register
               
_timer3_init:
                clr.w   _timer3_counter16
                move.w  #0x1000, TIMER3_CONTROL_REGISTER |disable and clear
                move.w  #8,INTERRUPT_POLL_CLEAR_REGISTER_L |clr IRQ3 event
                move.w  #0xC163, TIMER3_CONTROL_REGISTER |10khz/100,  enable
                ori.w   #8,INTERRUPT_MASK_REGISTER_L    |enable IRQ
                rts
|---------------------------------------------------------------------------
                .align  2

_timer3_counter16:
                .ds.w   1 
|---------------------------------------------------------------------------
